package rocks.zipcode;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final FileWriter fileWriter;
    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
        this.fileWriter = new FileWriter(file);
    }

    @Override
    public void write(String contentToBeWritten) {
        try {
            fileWriter.write(contentToBeWritten);
            fileWriter.flush();
            //fileWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {

        }

    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten) {
//
        try {
            StringBuilder sb=new StringBuilder() ;
            try {
                BufferedReader  fileReader =new BufferedReader( new FileReader( file)) ;
                String fileread ="";
                int i=0;
                while((fileread =fileReader.readLine()) !=null){
                    if(lineNumber==i) {
                        sb.append(valueToBeWritten);
                    } else {
                        sb.append(fileread);
                    }
                    sb.append("\n");
                    i++;
                }
                overWrite(sb.toString());
            }catch (Exception e) {
                e.printStackTrace();
            }




        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public String read(Integer lineNumber) {
        try {
            //return new String(Files.readAllBytes(Paths.get(file.getPath())));
            String str = new String(Files.readAllLines(Paths.get(file.getPath())).get(lineNumber));
            return str;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }

    }

    @Override
    public String read() {

        StringBuilder sb=new StringBuilder() ;
        try {
          BufferedReader  fileReader =new BufferedReader( new FileReader( file)) ;
           String fileread ="";
            while((fileread =fileReader.readLine()) !=null){
            sb.append(fileread);
            sb.append("\n") ;

        } }catch (Exception e) {
            e.printStackTrace();
        }
        return sb.toString().trim() ;
//        try {
//            return new String(Files.readAllBytes(Paths.get(file.getPath())));
//        } catch (Exception e) {
//            e.printStackTrace();
//            return null;
//        }

    }


    @Override
    public void replaceAll(String stringToReplace, String replacementString) {  //NOT WORKING
        try{


        String strFileInputs = read();
            System.out.println("Inside replaceAll method -  After reading the input - " + strFileInputs );
            Pattern ptn = Pattern.compile(stringToReplace );
            Matcher mtch = ptn.matcher(strFileInputs  );
            String replaced=mtch.replaceAll(replacementString );

        overWrite(replaced ) ;

            }catch (Exception e ){
                e.printStackTrace() ;
            }

    }
    @Override
    public void overWrite(String content) {

        try {

            FileWriter fstream = new FileWriter(file, false);
            fstream.write(content);
            fstream.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public List<String> toList() {

        List<String> list = null;
        try (Stream<String> lines = Files.lines(Paths.get(file.getPath()))) {
            list = lines.collect(Collectors.toList());
        } catch (IOException e) {
            e.printStackTrace();
        }
        return list;
    }

    @Override
    public File getFile() {
        try {
            String str = "";
            ClassLoader cl = getClass().getClassLoader();
            File file = new File(cl.getResource(str).getFile());
            return file;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String toString() {
        try {
            StringBuilder sb=new StringBuilder() ;
            String filepath=file.toString() ;
            String str= new String(Files.readAllBytes(Paths.get(file.getPath())));
            sb.append(filepath ) ;
            sb.append( "{");
            sb.append(str) ;
            sb.append("}");

            return sb.toString() ;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
